      program prd_2d_qs_dr

c=========================================
c FDLIB, BEMLIB
c
c Copyright by C. Pozrikidis, 1999
c All rights reserved
c
c This program is to be used only under the
c stipulations of the licencing agreement
c=========================================

c-------------------------------------
c  point distribution on a closed line
c  with four planes of symmetry
c-------------------------------------

      Implicit Double Precision (a-h,o-z)

      Dimension X  (0:900),Y  (0:900)
      Dimension P1 (0:900),P2 (0:900)
      Dimension P3 (0:900)
      Dimension P4 (0:900),P5 (0:900)

      Dimension XC (900),YC (900),R  (900),S  (900)
      Dimension TH1(900),TH2(900),TH3(900),ORNT(900)

      common/XXYY/X,Y
      common/ARCC/XC,YC,R,S,TH1,TH2,TH3,ORNT

c---
c constants
c---

      pi  = 3.14159 265358 979323 84D0
      pih = 0.5D0*pi
      pi2 = 2.0D0*pi

      Null = 0
c---
c input parameters
c---

      open (1,file="prd_2d_qs.dat",status="unknown")

       read (1,*) thmax
       read (1,*) spmin
       read (1,*) spmax

      close (1)

      write (6,*)
      write (6,*) ' Enter:'
      write (6,*)
      write (6,*) ' 1 to generate shape '
      write (6,*) ' 2 to read it from prd_2d_qs.inp'
      write (6,*) ' 0 to quit'
      write (6,*) ' ---------'
      read  (5,*) Iread

      if(Iread.eq.0) Go to 99

c---
c born to run
c---

      thmax = thmax*pi

      open (2,file="prd_2d_qs.out",status="unknown")

c----------------------------------
c generate the primary distribution
c----------------------------------

      if(Iread.eq.1) Then

       centerx = 0.0
       centery = 0.0

       write (6,*)
       write (6,*) ' Will generate an elliptical shape'
       write (6,*)
       write (6,*) ' Enter the x semi-axis'
       write (6,*) ' such as 1.0'
       write (6,*) ' ---------------------'
       read  (5,*) a

       write (6,*)
       write (6,*) ' Enter the y semi-axis'
       write (6,*) ' such as 0.5'
       write (6,*) ' -----------'
       read  (5,*) b

       write (6,*)
       write (6,*) ' The number of segments is 4*M'
       write (6,*) ' Enter M'
       write (6,*) ' such as 12'
       write (6,*) ' ----------'
       read  (5,*) MSG

       NSG = 4*MSG

       NSG1 = NSG+1
       NSG2 = NSG+2
       NSGQ = NSG/4+1

       Dth = pi2/(NSG1-1.0D0)

       Do i=0,NSGQ

        thet  = (i-1.0)*Dth
        X(i)  = centerx + a*cos(thet) + 0.2*a*cos(thet)**2
        Y(i)  = centery + b*sin(thet)

        thet2 = 2.0*thet

        P1(i) = cos(thet)**2
        P2(i) = sin(thet)**2
        P3(i) = sin(thet2)
        P4(i) = a*thet 
        P5(i) = sin(thet)**3

        write (6,104) i,X(i),Y(i),P1(i),P2(i),P3(i),P4(i),P5(i)

       End Do
c---
      else
c---
      open (8,file="prd_2d_qs.inp",status="unknown")

       read (8,*) NSGQ
       NSG  = (NSGQ-1)*4
       NSG1 = NSG + 1
       NSG2 = NSG + 2
       Do i=1,NSGQ
        read (8,*) idle,X(i),Y(i),P1(i),P2(i)
     +                           ,P3(i),P4(i),P5(i)
       End Do

      close (8)
c---
      end if
c---

c-----------------
c printing session
c-----------------

      write (6,*)
      write (6,*)  "Primary distribution:"
      write (6,*)

      write (2,104) NSGQ

      Do i=1,NSGQ
        write (2,104) i,X(i),Y(i),P1(i),P2(i),P3(i),P4(i),P5(i)
        write (6,104) i,X(i),Y(i),P1(i),P2(i),P3(i),P4(i),P5(i)
      End Do

c---
c redistribution
c---
      ICH1 = 1
      ICH2 = 1
      ICH3 = 1

      call prd_2d_qs 

     +   (NSG
     +   ,ICH1,thmax
     +   ,ICH2,spmax
     +   ,ICH3,spmin
     +   ,AAAA,BBBB
     +   ,CCCC,DDDD
     +   ,P1,P2,P3,P4,P5
     +   ,Istop
     +   )

      NSGQ = NSG/4+1
c---
c printing
c---

      write (6,*)
      write (6,*)  "Revised distribution:"
      write (6,*)
      write (2,104) NSGQ

      Do i=1,NSGQ
       write (2,104) i,X(i),Y(i),P1(i),P2(i),P3(i),P4(i),P5(i)
       write (6,104) i,X(i),Y(i),P1(i),P2(i),P3(i),P4(i),P5(i)
      End Do

c---
c done
c---

      write (2,104) Null
      close (2)

  99  Continue
       
 104  Format (1X,I3,20(1X,F8.4))

      stop
      end
