      subroutine draw_arrow_2d
     +
     +   (x1,y1
     +   ,dx,dy
     +   ,vector
     +   )

c-----------------------------------------
c FDLIB
c
c Copyright by C. Pozrikidis, 1999
c All rights reserved
c
c This program is to be used only under the
c stipulations of the licensing agreement
c----------------------------------------

c--------------------------------------
c Generate coordinates for plotting
c a five-point arrow starting at the point
c (x1,x2) and ending at the point (x1+dx, y1+dy)
c
c SYMBOLS:
c --------
c
c dx, dy: arrow vector
c
c vector(i,1): x-coordinate of the ith point
c vector(i,2): y-coordinate of the ith point
c              where i=1,2,3,4,5
c
c angle:  angle of arrow tip in radians
c
c tip:    length of arrow tip sides
c         as a fraction of the arrow length
c---------------------------------------

      Dimension vector(5,2)

      Parameter (angle=0.3,tip=0.50)

c--------
c prepare
c--------

      x2 = x1+dx
      y2 = y1+dy

      cs = cos(angle)
      sn = sin(angle)

      dxi = -dx
      dyi = -dy

c------------
c first point
c------------

      vector(1,1) = x1
      vector(1,2) = y1

c---
c second point
c---

      vector(2,1) = x2
      vector(2,2) = y2

c---
c third point
c---

      vector(3,1) = x2+( dxi*cs+dyi*sn)*tip
      vector(3,2) = y2+(-dxi*sn+dyi*cs)*tip

c---
c fourth point
c---

      vector(4,1) = x2
      vector(4,2) = y2
c---
c fifth point
c---

      vector(5,1) = x2+(dxi*cs-dyi*sn)*tip
      vector(5,2) = y2+(dxi*sn+dyi*cs)*tip

c-----
c done
c-----

      return 
      end
