      subroutine grid_2d
     +
     +  (ax,bx
     +  ,ay,by
     +  ,Nx,Ny
     +  )

c-----------------------------------------------
c  Generate a uniform Cartesian grid within
c  a rectangular area
c
c  SYMBOLS:
c  --------
c
c  Nx :  number of x intervals
c  Ny :  number of y intervals
c
c  Dx :  length of x interval
c  Dy :  length of y interval
c
c  glx(i) :  x-position of vertical ith grid line
c  gly(i) :  y-position of horizontal ith grid line
c
c  [gx(i,j), gy(i,j)] : coordinates of (i,j) grid point
c-----------------------------------------------

      Dimension glx(129), gly(129)
      Dimension gx(129,129),gy(129,129)

c---
c common blocks
c---

      common/grid_2d_1/glx,gly
      common/grid_2d_2/gx,gy

c---
c prepare
c---

      Dx = (bx-ax)/Nx
      Dy = (by-ay)/Ny

      Nx1 = Nx+1
      Ny1 = Ny+1

c---
c generate the grid lines
c---

      Do i=1,Nx1
       glx(i) = ax+(i-1.0)*Dx
      End Do

      Do i=1,Ny1
       gly(i) = ay+(i-1.0)*Dy
      End Do

c---
c generate the grid points
c---

      Do i=1,Nx1
       Do j=1,Ny1
        gx(i,j) = glx(i)
        gy(i,j) = gly(j)
       End Do
      End Do

c---
c Done
c---

      Return
      End
