function [glx,gly,gx,gy] = grid_2d (ax,bx,ay,by,Nx,Ny)

%=========================================
% Generate a grid in the xy plane
%
%  glx:     vertical grid lines
%  gly:     horizontal grid lines
% (gx, gy): coordinates of the grid points
%=========================================

%-----
% prepare
%-----

Dx = (bx-ax)/Nx;
Dy = (by-ay)/Ny;

%---
% generate the grid lines
%---

 for i=1:Nx+1
   glx(i) = ax+(i-1.0)*Dx;
 end

 for j=1:Ny+1
   gly(j) = ay+(j-1.0)*Dy;
 end

%---
% generate the grid points
%---

 for i=1:Nx+1
   for j=1:Ny+1
     gx(i,j) = glx(i);
     gy(i,j) = gly(j);
   end
 end

%---
% done
%---

return
