      program chan_2d_imp_dr

c=========================================
c FDLIB
c
c Copyright by C. Pozrikidis, 1999
c All rights reserved.
c
c This program is to be used only under the
c stipulations of the licensing agreement
c=========================================

c=========================================
c Flow in a channel confined between two parallel walls
c due to the impulsive motion of the lower wall
c parallel to itself with constant velocity.
c
c The walls are located at y = 0, h
c=========================================

      Implicit Double Precision (a-h,o-z)

c---
c constants
c---

      Null = 0
      None = 1
      Ntwo = 2

      zero = 0.0

c------
c input
c------

      open (1,file="chan_2d_imp.dat",status="unknown")

       read (1,*) nprof   ! number of points for drawing a profile
       read (1,*) h       ! channel width
       read (1,*) visc    ! fluid viscosity
       read (1,*) den     ! fluid density
       read (1,*) V       ! wall velocity
       read (1,*) Max     ! maximum number of terms in summed series

      close (1)

c---------------
c prepare to run
c---------------

      open (2,file='chan_2d_imp.out')

c---------------------------
c data to plot channel walls
c---------------------------

      write (2,900) Ntwo
      write (2,900) None,-h,zero
      write (2,900) Ntwo, h,zero
      write (2,900) Ntwo
      write (2,900) None,-h,h
      write (2,900) Ntwo, h,h

c----------
c main menu
c----------

      write (6,*)
      write (6,*)  " Enter 0 to quit"
      write (6,*)  "       1 for one profile"
      write (6,*)  "------------------------"
      read  (5,*) menu

      If(menu.eq.0) Go to 99

c------------
c one profile
c------------

      If(menu.eq.1) then

      nprof1 = nprof+1
      step   = h/(nprof1-1.0)

 94   Continue

      write (6,*)
      write (6,*) " Please enter the time"
      write (6,*) " 99 to quit"
      write (6,*) " ----------"
      read (5,*) time

      If(time.eq.99) Go to 99

c-------------------
c Generate a profile
c-------------------

      write (6,*)
      write (6,*) "u, y"
      write (6,*)

      write (2,900) nprof1

      y = 0.0

      Do i=1,nprof1

       call chan_2d_imp
     +
     +    (h
     +    ,visc
     +    ,den
     +    ,V
     +    ,Max
     +    ,time
     +    ,y
     +    ,u
     +    )

       write (2,900) i,u,y
       write (6,900) i,u,y

       y = y +step

      End Do

c---
c done with the profile
c---

      Go to 94

      End If

c-----
c done
c-----

  99  Continue

      write (2,900) null
      close (2)

      write (6,*)
      write (6,*) " If underflow has occurred"
      write (6,*) " please reduce the value of Max"
      write (6,*)

 900  Format (1x,i3,4(1x,f10.5))

      Stop
      End
