function [A,f,Iflag] = chan_pl ...
     ...
    (chi ...
    ,rho  ...
    ,gx ...
    ,a ...
    ,mu0 ...
    ,n ...
    ,V1 ...
    ,V2 ...
    ,Niter ...
    ,eps ...
    ,A ...
    ,tol ...
    ,italk ...
    )

%-----------------------------------
% Solve one nonlinear equation
% for the channel flow of a power-law fluid
% by the second-order Newton method
%-----------------------------------

    Iflag = 1;

    for i=1:Niter

       f = chan_pl_fun(chi,rho,gx,a,mu0,n,V1,V2,A);
       A1 = A + eps;     % derivative by finite differences
       f1 = chan_pl_fun(chi,rho,gx,a,mu0,n,V1,V2,A1);
       Df = (f1-f)/eps;
       DA = -f/Df;
       A = A+DA;

        if(italk==1)
         format long
         disp([A,f])
        end

      iescape = 1;
      if(abs(DA) > tol) iescape = 0; end

      if(iescape==1)
       Iflag = 0;
       f = chan_pl_fun(chi,rho,gx,a,mu0,n,V1,V2,A);
       return
      end

    end

%---
% done
%---

 return
