clear all
close all

%----
% draw velocity profiles
% of the channel flow
% of a power-law fluid
%----

a = 1.0;
chi = 2.0;
rho = 1.0;
gx = 0.0;
mu0 = 1.0;
V1 =  0.0;
V2 = 0.0;
V1 = -0.5;
V2 = 1.0;
Niter = 10;
eps = 0.01;

tol = 0.0000001;

%---
% prepare
%---

tmp = chi+rho*gx;
mu = 1.0;
umean = 0.5*(V1+V2) + 1/3 *tmp/mu * a^2;

%---
% prepare to plot
%---

figure(1)
hold on
xlabel('u_x/u_{mean,n=1}','fontsize',15)
ylabel('y/a','fontsize',15)
set(gca,'fontsize',15)
box on

A = (V2-V1)/(2*a);
italk = 0;
Iflag = 1;

%---
for irepeat = 1:3
%---

if(irepeat==1)
n = 0.5;
elseif(irepeat==2)
n = 1.0;
elseif(irepeat==3)
n = 2.0;
end

[A,f,Iflag] = chan_pl ...
     ...
    (chi ...
    ,rho ...
    ,gx ...
    ,a ...
    ,mu0 ...
    ,n ...
    ,V1 ...
    ,V2 ...
    ,Niter ...
    ,eps ...
    ,A ...
    ,tol ...
    ,italk ...
    );

B = V2 +n/(n+1)/tmp/mu0^(1/n) * abs(A-tmp*a)^(1+1/n);

Nplot = 32;
Dy = 2*a/Nplot;

for i=1:Nplot+1
  y(i) = -a+(i-1)*Dy;
  u(i) = -n/(n+1)/tmp/mu0^(1/n) * abs(A-tmp*y(i))^(1+1/n)+B;
end

if(irepeat==1)
 plot(u/umean,y,'k--')
elseif(irepeat==2)
 plot(u/umean,y,'k')
elseif(irepeat==3)
 plot(u/umean,y,'ko-')
end

%---
end
%---
