      program plate_imp_dr

c-----------------------------------------
c FDLIB
c
c Copyright by C. Pozrikidis, 1999
c All rights reserved.
c
c This program is to be used only under the
c stipulations of the licensing agreement.
c----------------------------------------

c--------------------------------------------
c Flow due to the impulsive motion of a plate
c in a semi-infinite fluid
c
c Equation (5.2.11) of Pozrikidis (1997,p.195)
c--------------------------------------------

      Implicit Double Precision (a-h,o-z)

c----------
c constants
c----------

      null = 0
      None = 1
      Ntwo = 2

c---
c Input
c---

      open  (1,file="plate_imp.dat",status="unknown")
       read (1,*) nprof
       read (1,*) ymax
       read (1,*) visc
       read (1,*) den
       read (1,*) Up
      close (1)

c--------
c prepare
c--------

      open(2,file="PLOTDAT",status="unknown")

      nprof1 = nprof+1
      step   = ymax/(nprof1-1.0)

c---
c plot the plate
c---

      write (2,900) Ntwo
      write (2,900) None,-ymax,zero
      write (2,900) Ntwo, ymax,zero

c---
c plot a vertical line
c---

      write (2,900) Ntwo
      write (2,900) None,zero,zero
      write (2,900) Ntwo,zero,ymax

 95   Continue

      write (6,*)
      write (6,*) " Please enter the time"
      write (6,*) "            99 to quit"
      write (6,*) " ---------------------"
      read  (5,*) time

      If(time.eq.99) Go to 99

      If(abs(time).lt.0.000000001) then
        write (6,*) " Sorry, time too short to handle numerically"
        write (6,*) " Try again"
        Go to 95
      End If

      write (6,*)
      write (6,*) " u, y"
      write (6,*)

      write (2,900) nprof1

      y = 0.0

      Do i=1,nprof1

      call plate_imp
     +
     +    (visc
     +    ,den
     +    ,Up
     +    ,time
     +    ,y
     +    ,u
     +    )

       write (2,900) i,u,y
       write (6,900) i,u,y

       y = y+step

      End Do

      Go to 95
c---
c done
c---

  99  Continue

      write (2,900) Null

      close (2)

 900  Format (1x,i3,4(1x,f10.5))

      Stop
      End
