      subroutine ell_int (RK2,F,E)

c-----------------------------------------
c Copyright by C. Pozrikidis, 1999
c All rights reserved.
c
c This program is to be used only under the
c stipulations of the licencing agreement.
c----------------------------------------

c-------------------------------------------
c
c  COMPUTATION OF COMPLETE ELLIPTIC INTEGRALS
c  OF THE FIRST AND SECOND KIND
c
c   acc: measure of accuracy
c
c-------------------------------------------

      Implicit Double Precision (A-H,O-Z)

      Parameter (acc=0.0000000001)

      pi = 3.14159 265358
      
      RK = sqrt(RK2)
      F  = 0.5*pi
      E  = 1.0
      G  = 1.0
      B  = RK
 
  1   Continue
c     Do while (abs(D).GT.acc)

      C = sqrt(1.0-B**2)
      B = (1.0-C)/(1.0+C)
      D = F*B
      F = F+D
      G = 0.50*G*B
      E = E+G

c     End Do
      If(abs(D).gt.acc) Go to 1

      E = F*(1.0-0.50*RK2*E)
 
      Return
      End
