      subroutine ps_ring_w (wall,x,s,x0,s0,u,v)

c-----------------------------------------
c Potential flow:
c
c ring of point sources in front of a wall
c-----------------------------------------

      Implicit Double Precision (a-h,o-z)

c---
c primary ring
c---

      Dx   = x-x0
      Dxs  = Dx*Dx
      ss0s = (s+s0)**2
      rks  = 4.0*s*s0/(Dxs+ss0s)

      call ell_int (rks,F,E)

      tmp1 = sqrt(Dxs+ss0s)
      rksc = 1.0-rks
      RJ30 = E/rksc
      RJ31 = (-2.0*F+(2.0-rks)*E/rksc)/rks
      cf   = 4.0/tmp1**3
      RI30 = cf*RJ30
      RI31 = cf*RJ31

      u    = - dx * RI30
      v    = - s*RI30+s0*RI31

c---
c image ring
c---

      x0i = 2.0*wall-x0
      Dx  = x-x0i
      Dxs = Dx*Dx
      rks = 4.0*s*s0/(Dxs+ss0s)

      call ell_int (rks,F,E)

      tmp1 = sqrt(Dxs+ss0s)
      rksc = 1.0-rks
      RJ30 = E/rksc
      RJ31 = (-2.0*F+(2.0-rks)*E/rksc)/rks
      cf   = 4.0/tmp1**3
      RI30 = cf*RJ30
      RI31 = cf*RJ31

      u    = u - dx * RI30
      v    = v - s*RI30+s0*RI31

c-----
c Done
c-----

      Return
      End
