      subroutine sphrd_ob_axial (x,y,c,delx,f)

c---
c Potential flow past a prolate spheroid
c Analytical solution 
c---

      Implicit double precision (a-h,o-z)

c---
c find the value of zeta and mu
c---

      aq = c*c
      bq = -x*x-y*y+c*c
      cq = -x*x
      discr = bq*bq-4.0*aq*cq
      if(discr.lt.0) stop
      discr = sqrt(discr)
      zetas = (-bq+discr)/(2.0*aq)
      zeta  = sqrt(zetas)
      rmu = x/(c*zeta)

      f = rmu*(1.0-zeta*atan(1.0/zeta))/delx

      f = -f+x

c---
c done
c---

      return
      end
