      subroutine tube_ann_sw
     +
     +  (a1
     +  ,a2
     +  ,visc
     +  ,omega1
     +  ,omega2
     +  ,s
     +  ,Q
     +  ,torque
     +  ,u
     +  )

c========================================
c FDLIB
c
c Copyright by C. Pozrikidis, 1999
c All rights reserved
c
c This program is to be used only under the
c stipulations of the licensing agreement
c========================================

c========================================
c Steady swirling flow in an annular tube
c confined between two concentric cylinders
c with radii a1 and a2
c
c The cylinders rotate with angular velocities 
c Omega1 and Omega2
c========================================

      Implicit Double Precision (a-h,o-z)

c---
c constants
c---

      pi  = 3.14159 265358 D0

c---
c prepare
c---

      a1s = a1**2
      a2s = a2**2
      al  = a1s/a2s
      ac  = 1.0-al

      Domega = omega2-omega1

c---
c velocity evaluation
c---

      u = s*(omega2-al*omega1)/ac - Domega*a1s/(ac*s)

c---
c flow rate
c---

      Q = 0.5*(a2**2-a1**2)*(omega2-a*omega1)/ac
     +    -Domega*a1s/ac * log(a2/a1)
c---
c torque
c---

      torque = -4.0*pi*visc*Domega*a1s/ac

c-----
c Done
c-----

      Return
      End
