%----
close all
clear all
%----

%=======================
% visualize an annular swirling multi-layer flow
%
% data are read from file: tube_ann_sw_ml.out
%=======================

figure(1)
hold on
%xlabel('x','fontsize',15)
%ylabel('y','fontsize',15)

file2 = fopen('tube_ann_sw_ml.out');

NLR = fscanf(file2,'%f',[1,1]);

% inner cylinder

N   = fscanf(file2,'%f',[1,1]);
for i=1:N
 idle   = fscanf(file2,'%f',[1,1]);
 x(i)   = fscanf(file2,'%f',[1,1]);
 y(i)   = fscanf(file2,'%f',[1,1]);
end
patch(x,y,'y')
plot(x,y,'r','linewidth',3);
clear x y

% outer cylinder

N   = fscanf(file2,'%f',[1,1]);
for i=1:N
 idle   = fscanf(file2,'%f',[1,1]);
 x(i)   = fscanf(file2,'%f',[1,1]);
 y(i)   = fscanf(file2,'%f',[1,1]);
end
plot(x,y,'r','linewidth',3);
clear x y

% interfaces

for j=1:NLR-1
N   = fscanf(file2,'%f',[1,1]);
for i=1:N
 idle   = fscanf(file2,'%f',[1,1]);
 x(i)   = fscanf(file2,'%f',[1,1]);
 y(i)   = fscanf(file2,'%f',[1,1]);
end
plot(x,y,'k','linewidth',2);
end
clear x y

% vertical line

N   = fscanf(file2,'%f',[1,1]);
for i=1:N
 idle   = fscanf(file2,'%f',[1,1]);
 x(i)   = fscanf(file2,'%f',[1,1]);
 y(i)   = fscanf(file2,'%f',[1,1]);
end
plot(x,y,'k','linewidth',1);
clear x y

% velocity profile

Nproftot   = fscanf(file2,'%f',[1,1]);
for i=1:Nproftot
 idle   = fscanf(file2,'%f',[1,1]);
 x(i)   = fscanf(file2,'%f',[1,1]);
 y(i)   = fscanf(file2,'%f',[1,1]);
end
plot(x,y,'k','linewidth',2);
clear x y

%fclose(file2)

set(gca,'fontsize',15)
box on
axis equal
axis off

