      subroutine tube_crc
     +
     +  (a
     +  ,visc
     +  ,den
     +  ,gac
     +  ,chi
     +  ,beta
     +  ,s
     +  ,flow_rate
     +  ,umean
     +  ,umax
     +  ,u
     +  )

c========================================
c Copyright by C. Pozrikidis, 1999
c All rights reserved.
c
c This program is to be used only under the
c stipulations of the licensing agreement
c========================================

c-------------------------------------
c Steady flow through a circular tube
c due to gravity or pressure gradient
c
c a:   tube radius
c chi: negative of the pressure gradient
c--------------------------------------

      Implicit Double Precision (a-h,o-z)

c----------
c constants
c----------

      pi = 3.14159 265358 D0

c---
c prepare 
c---

      area = pi*a*a

      pg_mod = chi+den*gac*sin(beta)

c--------------------
c velocity evaluation
c--------------------

      u = 0.25D0*pg_mod/visc*(a**2-s**2)

c---
c Flow rate, mean velocity, max velocity
c---

      flow_rate = pi*pg_mod*a*a*a*a/(8.0D0*visc)
      umean = flow_rate/area
      umax  = 2.0D0*umean

c-----
c Done
c-----

      Return
      End
