clear all
close all

%=============================================
% Multi-layer core-annular flow through a circular tube
%=============================================

%---
% input
%---

beta = 0.125;      %  inclination angle (in multiples of pi)
gac = 1.0;         %  acceleration of gravity
a = 1.0;           %  tube radius
chi = 2.000000;    %  chi: negative of the pressure gradient

NLR = 5;           %  Number of layers (NLR)
thick = [0.30 0.228 0.23 0.1]; %  layer thicknesses
visc   = [1.0   1.2   0.9 1.0 2.0]; % layer viscosities
den   = [1.0   1.7   3.6 3.4 5.6]; % layer densities

%---
% last layer thickness
%---

sum = 0.0;

for i=1:NLR-1
  sum = sum+thick(i);
end

thick(NLR) = a-sum;

%---
% prepare
%---

beta = beta*pi;

%---
% launch
%---


s = 0.2;

[sI,uI,xi1,xi2,Q,u] = tube_crc_ml ...
...
    (NLR ...
    ,a ...
    ,thick ...
    ,visc ...
    ,den ...
    ,gac ...
    ,chi ...
    ,beta ...
    ,s...
    )
