%----
close all
clear all
%----

%=======================
% visualize a multi-layer core-annular flow
%
% data are read from file: tube_crc_ml.out
%=======================

figure(1)
hold on
%xlabel('x','fontsize',15)
%ylabel('y','fontsize',15)

file2 = fopen('tube_crc_ml.out');

NLR = fscanf(file2,'%f',[1,1]);

% cylinder

N   = fscanf(file2,'%f',[1,1]);
for i=1:N
 idle   = fscanf(file2,'%f',[1,1]);
 x(i)   = fscanf(file2,'%f',[1,1]);
 y(i)   = fscanf(file2,'%f',[1,1]);
end
patch(x,y,'r');
clear x y

% cylinder reflection

N   = fscanf(file2,'%f',[1,1]);
for i=1:N
 idle   = fscanf(file2,'%f',[1,1]);
 x(i)   = fscanf(file2,'%f',[1,1]);
 y(i)   = fscanf(file2,'%f',[1,1]);
end
patch(x,y,'r');
clear x y

% layers

for j=1:NLR

N   = fscanf(file2,'%f',[1,1]);
for i=1:N
 idle   = fscanf(file2,'%f',[1,1]);
 x(i)   = fscanf(file2,'%f',[1,1]);
 y(i)   = fscanf(file2,'%f',[1,1]);
end
if(mod(j,2)==0)
 patch(x,y,'w');
else
 patch(x,y,'y');
end
N   = fscanf(file2,'%f',[1,1]);
for i=1:N
 idle   = fscanf(file2,'%f',[1,1]);
 x(i)   = fscanf(file2,'%f',[1,1]);
 y(i)   = fscanf(file2,'%f',[1,1]);
end
if(mod(j,2)==0)
 patch(x,y,'w');
else
 patch(x,y,'y');
end

end
clear x y

% centerline

N   = fscanf(file2,'%f',[1,1]);
for i=1:N
 idle   = fscanf(file2,'%f',[1,1]);
 x(i)   = fscanf(file2,'%f',[1,1]);
 y(i)   = fscanf(file2,'%f',[1,1]);
end
plot(x,y,'k','linewidth',1);
clear x y

% vertical line at x=0

N   = fscanf(file2,'%f',[1,1]);
for i=1:N
 idle   = fscanf(file2,'%f',[1,1]);
 x(i)   = fscanf(file2,'%f',[1,1]);
 y(i)   = fscanf(file2,'%f',[1,1]);
end
plot(x,y,'k','linewidth',1);
clear x y

% velocity profile

Nproftot   = fscanf(file2,'%f',[1,1]);
for i=1:Nproftot
 idle   = fscanf(file2,'%f',[1,1]);
 x(i)   = fscanf(file2,'%f',[1,1]);
 y(i)   = fscanf(file2,'%f',[1,1]);
end
plot(x,y,'k','linewidth',2);
Nproftot   = fscanf(file2,'%f',[1,1]);
for i=1:Nproftot
 idle   = fscanf(file2,'%f',[1,1]);
 x(i)   = fscanf(file2,'%f',[1,1]);
 y(i)   = fscanf(file2,'%f',[1,1]);
end
plot(x,y,'k','linewidth',2);
clear x y
clear x y

%fclose(file2)

set(gca,'fontsize',15)
box on
axis equal
axis off



