      subroutine thomas (N,a,b,c,s,x)

c=======================================
c FDLIB
c
c Copyright by C. Pozrikidis, 1999
c All rights reserved.
c
c This program is to be used only under the
c stipulations of the licencing agreement
c=======================================

c==========================================
c Thomas algorithm for tridiagonal systems
c 
c Algorithm 3.4.1
c==========================================

      Implicit Double Precision (A-H,O-Z)

      Dimension a(200),b(200),c(200),s(200),x(200)
      Dimension d(200),y(200)

      Parameter (tol=0.000000001)

c---
c reduction to upper bidiagonal
c---

      d(1) = b(1)/a(1)
      y(1) = s(1)/a(1)

      Do i=1,N-2
       i1 = i+1
       Den   = a(i1)-c(i1)*d(i)
       d(i1) = b(i1)/Den
       y(i1) =(s(i1)-c(i1)*y(i))/Den
      End Do

      den   = a(n)-c(N)*d(n-1);
      y(N) = (s(N)-c(N)*y(N-1))/den;

c---
c Back substitution
c---

      x(N) = y(N)
      Do i=N-1,1,-1
        x(i)= y(i)-d(i)*x(i+1)
      End Do

c---
c Verification and alarm
c---

      res = s(1)-a(1)*x(1)-b(1)*x(2)

      if(abs(res).gt.tol) then
       write (6,*)
       write (6,*) "thomas: alarm 1 in thomas algorithm"
       write (6,*)
      end if

      Do i=2,N-1
        res = s(i)-c(i)*x(i-1)-a(i)*x(i)-b(i)*x(i+1)
        if(abs(res).gt.tol) then
         write (6,*)
         write (6,*) "thomas: alarm 2 in thomas algorithm"
         write (6,*)
        end if
      End Do

      res = s(N)-c(N)*x(N-1)-a(N)*x(N)

      if(abs(res).gt.tol) then
       write (6,*)
       write (6,*) " thomas: alarm 3 in thomas algorithm"
       write (6,*)
      end if

c---
c Done
c---

 100  Format (1x,f15.10)

      Return
      End
