function x = thomas (n,a,b,c,rhs)

%==========================================
% Thomas algorithm for a tridiagonal system
%
% n:     system size
% a,b,c: diagonal, superdiagonal,
%        and subdiagonal elements
% rhs:     right-hand side
%===========================================

%------------------------------
% reduction to upper bidiagonal
%------------------------------

d(1) = b(1)/a(1);
y(1) = rhs(1)/a(1);

for i=1:n-2
  i1 = i+1;
  den   = a(i1)-c(i1)*d(i);
  d(i1) = b(i1)/den;
  y(i1) = (rhs(i1)-c(i1)*y(i))/den;
end

den   = a(n)-c(n)*d(n-1);
y(n) = (rhs(n)-c(n)*y(n-1))/den;

%------------------
% back substitution
%------------------

x(n) = y(n);

for i=n-1:-1:1
  x(i)= y(i)-d(i)*x(i+1);
end

%-----
% done
%-----

return;
