      subroutine cvt_2d_fdm
     +
     +  (Nx,Ny
     +  ,beta
     +  ,Amat
     +  )

c================================
c Generate the coefficient matrix
c of the linear system
c
c SYMBOLS:
c -------
c
c Nmat: size of the matrix
c================================

      Implicit Double Precision (a-h,o-z)
      Dimension Amat(500,500)

c----------
c constants
c----------

      one = 1.0D0
      two = 2.0D0

c--------
c prepare
c--------

      Nx1 = Nx+1
      Nx2 = Nx+2

      Nmat = Ny*Nx1           ! size of the matrix

      cf1 = -2.0D0*(1.0D0+beta)

c------------
c initialize
c-----------

      Do i=1,Nmat
       Do j=1,Nmat
        Amat(i,j) = 0.0D0
       End Do
      End Do

c-------------------------
c Reset the five diagonals
c-------------------------

      Amat(1,1)   = cf1   ! first row
      Amat(1,2)   = two   ! first row
      Amat(1,Nx2) = 2.0D0*beta  ! first row

      Do i=2,Nx1
       Amat(i,i)     = cf1  ! first block
       Amat(i,i+1)   = one  ! first block
       Amat(i,i-1)   = one ! first block
       Amat(i,i+Nx1) = 2.0D0*beta ! first block
      End Do

      Do i=Nx2,Nmat-Nx1      ! intermediate blocks
       Amat(i,i)     = cf1
       Amat(i,i+1)   = one
       Amat(i,i-1)   = one
       Amat(i,i+Nx1) = beta
       Amat(i,i-Nx1) = beta
      End Do

      Do i=Nmat-Nx,Nmat-1
       Amat(i,i)      = cf1  ! last block
       Amat(i,i+1)    = one  ! last block
       Amat(i,i-1)    = one ! last block
       Amat(i,i-Nx1)  = beta
      End Do

      Amat(Nmat,Nmat)     = cf1   ! last row
      Amat(Nmat,Nmat-1)   = two   ! last row
      Amat(Nmat,Nmat-Nx1) = beta  ! last row

c------------------------------
c Reset the ones to twos
c and the faulty betas to zeros
c------------------------------

      Do i=2,Ny            ! run over horizontal partitions
       loc = (i-1)*Nx1+1
       Amat(loc,loc-1) = 0.0D0
       Amat(loc,loc+1) = 2.0D0
      End Do

      Do i=1,Ny-1          ! run over horizontal partitions
       loc = i*Nx1
       Amat(loc,loc-1) = 2.0D0
       Amat(loc,loc+1) = 0.0D0
      End Do

c-----
c Done
c-----

      Return
      End
