      subroutine matrix
     +
     +   (w,ws,ev,v,vc
     +   ,Ma,tau,Ca,Pe
     +   ,zR,zI
     +   ,AR,AI
     +   ,DTR,DTI
     +   )

c---------------------------------
c definition of the secular matrix
c---------------------------------

      Implicit Double Precision (a-h,o-z)

      Double Precision Ma

      Dimension AR(4,4),AI(4,4)

      common/pii/pi,pih,pi2,pis

c---

      AR(1,1) = 2.0D0*w
      AI(1,1) = 0.0D0
      AR(1,2) = 1.0D0
      AI(1,2) = 0.0D0
      AR(1,3) = 1.0D0
      AI(1,3) = 0.0D0
      AR(1,4) = 0.0D0
      AI(1,4) = 0.0D0
c---
      AR(2,1) = vc*(zR*ws+1.0D0)
      AI(2,1) = vc* zI*ws
      AR(2,2) = zR*ws + zR*w + 1.0D0
      AI(2,2) = zI*ws + zI*w
      AR(2,3) = v*(zR*ws-zR*w + 1.0D0)
      AI(2,3) = v*(zI*ws-zI*w )
      AR(2,4) =   zI * 2.0D0*pis*ev/(Ca*w)
      AI(2,4) = - zR * 2.0D0*pis*ev/(Ca*w)
c---
      AR(3,1) =  zR * ws*(1.0D0+v)
      AI(3,1) =  zI * ws*(1.0D0+v) - tau * vc
      AR(3,2) =  zR * ws
      AI(3,2) =  zI * ws - tau
      AR(3,3) = - zR*v*ws
      AI(3,3) = - zI*v*ws - v*tau
      AR(3,4) = 0.0D0
      AI(3,4) = 0.0D0
c---

      AR(4,1) = Ma * w *(1.0D0+v)
      AI(4,1) =  0.0D0
      AR(4,2) = Ma * (1.0D0+w)
      AI(4,2) = 0.0D0
      AR(4,3) = Ma *v*(1.0D0-w)
      AI(4,3) = 0.0D0
      AR(4,4) = - zR * ev
      AI(4,4) = (- zI + pi2/Pe)*ev

c------
c print
c------

c     write (6,*)
c     Do i=1,4
c      write (6,101) (AR(i,j),j=1,4)
c     End Do
c     write (6,*)
c     Do i=1,4
c      write (6,101) (AI(i,j),j=1,4)
c     End Do
c     pause

      call Det_44c
     +
     +   (AR,AI
     +   ,DTR,DTI
     +   )

c-----
c Done
c-----

  101 Format (100(1x,F12.8))

      Return
      End
