      subroutine ifsf0_s
     +
     +  (RL         ! wave length
     +  ,vs1,vs2    ! viscosities
     +  ,rho1,rho2  ! densities
     +  ,gamma0     ! surface tension
     +  ,Ma         ! Marangoni number
     +  ,Ds         ! surfactant diffusivity
     +  ,xi         ! shear rate
     +  ,gac        ! accel of gravity
     +  ,cr1,si1    ! first mode
     +  ,cr2,si2    ! first mode
     +  )

c=======================================
c FDLIB
c
c Copyright by C. Pozrikidis, 1999
c All rights reserved
c
c This program is to be used only under the
c stipulations of the licensing agreement
c=======================================

c-----------------------------------------
c Instability of two interface between two
c semi-infinite fluids in simple shear flow
c in the presence of an insoluble surfactant
c
c Lower fluid is labeled 1
c Upper fluid is labeled 2
c------------------------------------------

      Implicit Double Precision (a-h,o-z)
      Double Precision Ma

c----------
c constants
c----------

      pi  = 3.14159 265358 D0
      pi2 = 2.0D0*pi

c--------
c prepare
c--------

      Drho = rho1-rho2

      wn = pi2/RL   ! wave number

c------------
c growth rate
c------------

      cr1 = 0.0D0
      si1 = -0.5D0*(gac*Drho/wn + wn*gamma0)/(vs1+vs2)

      cr2 = 0.0D0
      si2 = -0.5D0*Ma*gamma0*wn/(vs1+vs2)-wn*wn*Ds

c     write (6,*) cr1,si1
c     write (6,*) cr2,si2

c-----
c done
c-----

      Return
      End
