      subroutine thread1
     +
     +  (a,RL
     +  ,gamma,rho
     +  ,m
     +  ,cr,ci
     +  ,sr,si
     +  )

c==========================================
c FDLIB
c
c Copyright by C. Pozrikidis, 1999
c All rights reserved
c
c This program is to be used only under the
c stipulations of the licensing agreement
c==========================================

c-----------------------------------------------------
c Rayleigh capillary instability of an infinite thread
c of an inviscid fluid suspended in vacuum
c
c Formulas given on p. 475 of Pozrikidis (1997)
c-----------------------------------------------------

      Implicit Double Precision (a-h,o-z)

      Double precision k,I0,I1,K0,K1

c----------
c constants
c----------

      pi  = 3.14159 265358D0
      pi2 = 2.0D0*pi

c--------
c prepare
c--------

      k = pi2/RL      ! wave number
      x = k*a

      Iselect = 1            ! only I0 and I1 needed

      call bess_I01K01 
     +
     +  (x
     +  ,Iselect
     +  ,I0,I1,K0,K1
     +  )


c--------------------
      if(m.eq.0) then
c--------------------

        if(x.le.1.0D0) then
          cr = 0.0D0
          ci = gamma*I1/I0*(1.0D0-x*x)/(rho*a*x)
          ci = sqrt(ci)
        else
          cr = gamma*I1/I0*(x*x-1.0D0)/(rho*a*x)
          cr = sqrt(cr)
        end if

        sr = cr*k
        si = ci*k

c--------------------
      else if(m.eq.1) then
c--------------------

      I1p = I0-I1/x  ! first derivative of I1

      cr = - gamma*I1p/I1*(1.0-x*x-m*m)/(rho*a*x)
      cr = sqrt(cr)
      ci = 0.0D0

      sr = cr*k
      si = 0.0D0

c--------------------
      else 
c--------------------

      write (6,*)
      write (6,*) " thread1: sorry this azimuthal wave is not available"

c-----------
      end if
c-----------

c-----
c done
c-----

      return 
      end
