      program vs_dr 

c-----------------------------------------
c FDLIB
c
c Copyright by C. Pozrikidis, 1999
c All rights reserved.
c
c This program is to be used only under the
c stipulations of the licencing agreement.
c----------------------------------------

c----------------------------------------
c Complex phase velocity of perturbations 
c on a two-dimensional vortex sheet 
c----------------------------------------

      Implicit Double Precision (a-h,o-z)

c---
c input
c---

      open (1,file="vs.dat")

        read (1,*) RL        ! wave length
        read (1,*) denl      ! lower fluid density
        read (1,*) denu      ! upper fluid density
        read (1,*) gamma     ! surface tension
        read (1,*) Ul        ! lower fluid velocity
        read (1,*) Uu        ! upper fluid velocity
        read (1,*) gac       ! acceleration due to gravity

      close (1)

c---
c launch
c---

 97   Continue

      call vs 
     +
     +  (RL
     +  ,denl,denu
     +  ,gamma
     +  ,Ul,Uu,gac
     +  ,cr,ci
     +  ,sr,si
     +  )

      write (6,*) 
      write (6,*) " Complex phase velocity"
      write (6,*) 
      write (6,101) cr,ci
      write (6,*) 
      write (6,*) " Complex growth rate"
      write (6,*) 
      write (6,102) sr,si

      write (6,*) 
      write (6,*) ' Please enter new value of L'
      write (6,*) ' 0 to quit '
      write (6,*) '-----------'
      read  (5,*) RL

      if(RL.ne.0) Go to 97

c-----
c Done
c-----

 101  Format ("c_r = ",f15.10,/
     +       ,"c_i = ",f15.10)
 102  Format ("sigma_r = ",f15.10,/
     +        "sigma_i = ",f15.10)

      stop
      end
