      subroutine pv_pr
     +
     +  (x,y
     +  ,x0,y0
     +  ,RL
     +  ,u,v
     +  )

c-----------------------------------------
c FDLIB
c
c Copyright by C. Pozrikidis, 1999
c All rights reserved.
c
c This program is to be used only under the
c stipulations of the licencing agreement.
c----------------------------------------

c----------------------------------------------
c Periodic row of point vortices along the x axis.
c
c One of the point vortices located at (x0, y0).
c Formulas (11.2.15), p.529 of Pozrikidis (1997)
c
c RL: point vortex separation
c----------------------------------------------

      Implicit Double Precision (a-h,o-z)

c----------
c constants
c----------

      pi  = 3.14159265358D0
      pi2 = 2.0D0*pi

c--------
c prepare
c--------

      wn = pi2/RL    ! wave number

      dx = x-x0
      dy = y-y0

      A  = dx*wn
      B  = dy*wn
      dn = cosh(B)-cos(A)
      cf = 1.0D0/(2.0D0*RL*dn)

      u = - cf*sinh(B)
      v =   cf*sin (A)

c-----
c Done
c-----

      Return
      End
