      subroutine pv_ww
     +
     + (x,y
     + ,x0,y0
     + ,wall1
     + ,wall2
     + ,u,v
     + )

c-----------------------------------------
c FDLIB
c
c Copyright by C. Pozrikidis, 1999
c All rights reserved.
c
c This program is to be used only under the
c stipulations of the licencing agreement.
c----------------------------------------

c-----------------------------------------------------
c A point vortex between two parallel walls located at
c y = wall1 and y = wall2
c-----------------------------------------------------

      Implicit Double Precision (a-h,o-z)

c---
c constants
c---

      pi  = 3.14159 265358
      pi2 = 2.0*pi

c---
c prepare
c---

      h  = wall2-wall1
      wn = pi2/(2.0*h)  ! wave number (period twice wall separation)
      cf = 1.0/(4.0*h)

c---
c compute the velocity
c---

      A  = wn*(x-x0)
      B  = wn*(y-y0)
      Bi = wn*(y-2.0*wall1+y0)
      C  = cosh(A)
      D  = C-cos(B)
      Di = C-cos(Bi)

      u  = -cf*(sin(B)/D-sin(Bi)/Di)
      v  =  cf*sinh(A)*(1.0/D-1.0/Di)

c---
c Done
c---

      Return
      End
