function [Lam,lam] = crane_pohl(m,lam)

%--------
% find the root of the function F = 2mT+(m-1)*lam = 0
%--------

tol = 0.000001;
eps = 0.000001;
Lam = 6.0;

  Ic=0;
  for i=1:50
    fnc  = pscan(m,lam);
    fnc1 = pscan(m,lam+eps);
    fncp = (fnc1-fnc)/eps;
    corr = -fnc/fncp;
    lam  = lam+corr;
    Ic=Ic+1;
    if(abs(corr)<tol)
      Lam = root(lam,Lam);
      return;
    end
   end

   disp 'crane_pohl: could not find a root in 50 iterations'

%---
% done
%---

return

%================================

function F = pscan(m,lam)

%---
% compute the function F
%---

Lam = 6.0;
Lam = root(lam,Lam);

tmp = 23.0-11.0*Lam/12.0+Lam*Lam/72.0;
S = (2.0+Lam/6.0)*tmp/126.0;
T = S-2.0*lam;
F = 2*m*T + (m-1)*lam;

%---
% done
%---

return

%================================

function Lam = root(lam,Lam)

%---
% Solve for Lambda, given lambda
%---

tol = 0.000001;
eps = 0.000001;

 if(abs(lam)<0.000005)
   Lam = 0.00001;
   return
 end

%---
% Newton's method
%---

  Ic=0;
  for i=1:50
    fnc   = ltoL(lam,Lam);
    fnc1  = ltoL(lam,Lam+eps);
    fncp  = (fnc1-fnc)/eps;
    corr  = -fnc/fncp;
    Lam   = Lam+corr;
    Ic=Ic+1;
    if(abs(corr)<tol) return; end
   end

   disp 'root: could not find a root in 50 iterations'
   pause

%---
% done
%---

return

%================================

function f = ltoL(lam,Lam)

%---
% lambda to Lambda
%---

  f = Lam*( (23.0-11.0*Lam/12.0-Lam^2/72.0)/126.0 )^2 ...
   - lam;

%---
% done
%---

return

