close all
clear all

%---
% profiles of the Pohlhausen polynomials
%---

nplot=64;
Deta=1.0/nplot;

for i=1:nplot+1
  eta(i) = (i-1.0)*Deta;
end

figure(1)
hold on
xlabel('F','fontsize',15)
ylabel('\eta','fontsize',15)
set(gca,'fontsize',15)
box on
axis([-0.1 1.1 0 1])

for irepeat=1:7

 if(irepeat==1) lambda=20; end
 if(irepeat==2) lambda=12; end
 if(irepeat==3) lambda=6; end
 if(irepeat==4) lambda=0; end
 if(irepeat==5) lambda=-6; end
 if(irepeat==6) lambda=-12; end
 if(irepeat==7) lambda=-15; end

 for i=1:nplot+1
   et = eta(i);
   es = eta(i)^2;
   ec = eta(i)^3;
   F(i) = et*(2.0-2.0*es+ec)+lambda*et*(1.0-et)^3 /6.0;
%  F(i) = 1.0-F(i);
 end

 if(irepeat==6)
  plot(F,eta,'k--','linewidth',3)
 elseif(irepeat==2)
  plot(F,eta,'k','linewidth',3)
 else
  plot(F,eta,'k')
 end

end

