clear all
close all

%================================
% Unidirectinal flow in a channel
% by the explicit FTCS method
%================================

h = 1.0;
mu = 1.0;
rho = 1.0;
N = 32;
gx = 0.0;


dpdx = -8.0;
V1 = 0.0;
V2 = 0.0;

dpdx = 0.0;
V1 = 0.5;
V2 = 1.0;

al=0.40;  % alpha
nstep = 700;  % number of steps

al=0.51;  % alpha
nstep = 300;  % number of steps
nstep = 150;  % number of steps

mstep = 50  % number of steps for plotting

%---
% prepare
%---

nu =mu/rho;
Dy = h/N;
Dt = al*Dy*Dy/nu;

%---
% ploting
%---

figure(2)
set(gca,'fontsize',15)
axis([0 1.0 0 h])
xlabel('u','fontsize',15)
ylabel('y','fontsize',15)
hold on
box on

%---
% grid and initial condition
%---

for i=1:N+1
 y(i) = (i-1)*Dy;
 u(i) = 0;
end
u(1) = V1;
u(N+1) = V2;


t = 0.0;
istep = mstep;

%---
% time stepping
%---

for step=1:nstep

step

 t=t+Dt;
 unew(1) = V1;
 for i=2:N
  unew(i) = al*u(i-1)+(1-2*al)*u(i)+al*u(i+1) ...
   + Dt*(-dpdx/rho+gx);
 end
 unew(N+1) = V2;
 u = unew;

if(step==1)
  figure(1)
  Handle1 = plot(u,y,'ko-');
  set(Handle1, 'erasemode', 'xor');
  set(gca,'fontsize',15)
  axis([0 1.0 0 h])
  xlabel('u','fontsize',15)
  ylabel('y','fontsize',15)
else
  figure(1)
  set(Handle1,'XData',u,'YData',y);
  hold on
  pause(0.02)
  drawnow
end

  if(istep==mstep)
   figure(2)
   plot(u,y,'ko-');
   istep = 0;
  end

  istep = istep+1;

end
%---
