      subroutine arrow_2d
     +
     +  (x1,y1
     +  ,dx,dy
     +  ,vector
     +  )

c---------------------
c Draw a 5-point arrow
c starting at (x1,y1)
c with length (dx, dy)
c---------------------

      Dimension vector(5,2)

      parameter (angle=0.3, tip=0.50)

c--------
c prepare
c--------

      x2 = x1+dx
      y2 = y1+dy

      cs = cos(angle)
      sn = sin(angle)

      dxi = -dx
      dyi = -dy

c------------
c first point
c------------

      vector(1,1) = x1
      vector(1,2) = y1

c---
c second point
c---

      vector(2,1) = x2
      vector(2,2) = y2

c---
c third point
c---

      vector(3,1) = x2+( dxi*cs+dyi*sn)*tip
      vector(3,2) = y2+(-dxi*sn+dyi*cs)*tip

c---
c fourth point
c---

      vector(4,1) = x2
      vector(4,2) = y2

c---
c fifth point
c---

      vector(5,1) = x2+(dxi*cs-dyi*sn)*tip
      vector(5,2) = y2+(dxi*sn+dyi*cs)*tip

c-----
c Done
c-----

      Return 
      End
